/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : DL_U32_validation.h
   Author             : Rajesh
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the DataBase DataLayer 32-bit field Validation functions

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Rajesh

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef _DL_U32_VALIDATION_H_
#define	_DL_U32_VALIDATION_H_

/* USER CODE BEGIN EFP */
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
int8_t validate_cfg_frequency(uint16_t cfg_idx, uint32_t frequency);
int8_t validate_cfg_current(uint16_t cfg_idx, uint32_t current);
#endif

#if (SDK_SERVICE_PM == PS_ENABLE)
int8_t validate_rtcwakeup_timeout(uint16_t wakeup_idx, uint32_t timeout_val);
#endif

#if (SDK_SERVICE_FDCAN == PS_ENABLE)
int8_t validate_filter_index_id(uint16_t index_number ,uint32_t id);
int8_t validate_filter_index_idmask(uint16_t index_number ,uint32_t id);
#endif	//SDK_SERVICE_FDCAN

#if (THROUGH_PUT_SERVICE == PS_ENABLE)
int8_t validate_absolute_time(uint16_t db_idx, uint32_t a_time);
#endif

int8_t validate_dummy_field_val(uint16_t dummy1, uint32_t dummy2);
/* USER CODE END EFP */

#endif	//_DL_U32_VALIDATION_H_

/**************** (C) COPYRIGHT 2022 Maxima Technologies *******************/
/***************************** END OF FILE *********************************/
