/****************************************************************************
              Copyright (c) 2022 Maxima Technologies and Systems
                           All Rights Reserved

   File Name          : User_Define.h
   Author             : Adrush
   Version            : V0.0.0.1
   Origination Date   : 21/01/2022
   Description        : Header File.
   Environment        : Independent
   Processor:         : STM32H743IIT6

-----------------------------------------------------------------------------
   Description:

   This file contains the User Define Configuration macros

-----------------------------------------------------------------------------
	File Revision History:
-----------------------------------------------------------------------------
   Version             Date                 Programmer
   0.0.0.1             21/01/2022           Adrush

   Notes:              - Initial Version
-----------------------------------------------------------------------------
*****************************************************************************
THIS FILE CONTAINS INTELLECTUAL PROPERTY OF MAXIMA TECHNOLOGIES AND SYSTEMS.
UNAUTHORIZED REDISTRIBUTION OF THIS SOURCE CODE, IN WHOLE OR PART, WITHOUT
THE EXPRESS WRITTEN PERMISSION OF MAXIMA TECHNOLOGIES IS STRICTLY PROHIBITED.
****************************************************************************/

#ifndef _USER_DEFINE_H_
#define	_USER_DEFINE_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "../../../../Core/Maximatecc/Inc/common.h"
#include "../../../../Core/Maximatecc/Inc/Data_Layer.h"

#define KEY1_ACTIVE        0x01
#define KEY1_SHORT_PRESS   0x02
#define KEY1_LONG_PRESS    0x03

#define KEY2_ACTIVE        0x11
#define KEY2_SHORT_PRESS   0x12
#define KEY2_LONG_PRESS    0x13

#define KEY3_ACTIVE        0x21
#define KEY3_SHORT_PRESS   0x22
#define KEY3_LONG_PRESS    0x23

#define KEY4_ACTIVE        0x31
#define KEY4_SHORT_PRESS   0x32
#define KEY4_LONG_PRESS    0x33

#define ALARM_A_UPDATE     0x41
#define ALARM_B_UPDATE	   0x42


#ifdef __cplusplus
}
#endif

#endif	//_USER_DEFINE_H_
