/*
* ij1939_diagnostic.h - contains internal defines
*
* Copyright (c) 2019-2021 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: ij1939_diagnostic.h 38943 2021-11-26 14:32:44Z boe $
*
*-------------------------------------------------------------------
*
*
*
*/

/**
* \file
* \brief dataty type header
*/

#ifndef IJ1939_DIAGNOSTIC_H
#define IJ1939_DIAGNOSTIC_H 1


/* datatypes */

/* function prototypes */

RET_T	ij1939_DiagnosticInit(CO_LINE_DECL);
void	ij1939_diagnosticUpdateCobs(CO_LINE_DECL);
RET_T	ij1939_diagnosticMsgRequest(CO_LINE_DECL, UNSIGNED32 pgn,
			UNSIGNED8 reqAddr, const CO_CAN_REC_MSG_T *pMsg);
void	ij1939_diagnosticReceive(CO_LINE_DECL, UNSIGNED16 spec,
			const CO_CAN_REC_MSG_T *msg);
void	ij1939_diagtoolReceive(CO_LINE_DECL, UNSIGNED16	spec,
			const CO_CAN_REC_MSG_T *msg);
const	J1939_PGN_CONFIG_T *ij1939_diagnosticFindPgnConfig(CO_LINE_DECL,
			UNSIGNED32 recPgn);
const	J1939_PGN_CONFIG_T *ij1939_diagtoolFindPgnConfig(CO_LINE_DECL,
			UNSIGNED32 recPgn, UNSIGNED8 recSrc);
RET_T	ij1939_diagnosticRecIndication(CO_LINE_DECL, UNSIGNED32 pgn,
			UNSIGNED32 size, UNSIGNED8 node);
RET_T	ij1939_diagtoolRecIndication(CO_LINE_DECL, 
			const J1939_PGN_CONFIG_T *pCfg,
			const void *pMemory, UNSIGNED32 size, UNSIGNED8 srcAddr);

RET_T	ij1939_DiagnosticToolInit(CO_LINE_DECL);


#endif /* IJ1939_DIAGNOSTIC_H */
