#ifndef SCREEN1VIEW_HPP
#define SCREEN1VIEW_HPP

#include <gui_generated/screen1_screen/Screen1ViewBase.hpp>
#include <gui/screen1_screen/Screen1Presenter.hpp>

class Screen1View : public Screen1ViewBase
{
public:
    Screen1View();
    virtual ~Screen1View() {}
    virtual void setupScreen();
    virtual void tearDownScreen();
    virtual void keyUpdate(uint8_t val);
    virtual void trigger();
    virtual void watchdogstatus(uint8_t *val);

    void moveNext();
    void movePrevious();
    void moveNextScreen();
    void moveBackScreen();

protected:
    uint8_t  state;
    uint32_t key_position;
    uint8_t  digitalHours;
    uint8_t  digitalMinutes;
    uint8_t  digitalSeconds;
    int 	 tickCounter;
    uint8_t  ui_gauge;
    uint8_t  warning_light;
};

#endif // SCREEN1VIEW_HPP
