#include <gui/screen1_screen/Screen1View.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

Screen1View::Screen1View()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)
	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;

	/* Get the RTC DB */
	Get_DL(GET_RTC_SECOND, &Seconds);
	Get_DL(GET_RTC_MINUTE, &Minutes);
	Get_DL(GET_RTC_HOUR, &Hours);

    digitalHours = Hours;
    digitalMinutes = Minutes;
    digitalSeconds = Seconds;

    digitalClock1.invalidate();
#endif
}

void Screen1View::setupScreen()
{
    Screen1ViewBase::setupScreen();
}

void Screen1View::tearDownScreen()
{
    Screen1ViewBase::tearDownScreen();
}

void Screen1View::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		moveNextScreen();
	else
	if((KEY2_SHORT_PRESS == val) || (KEY2_LONG_PRESS == val))
		moveNext();
	else
	if((KEY3_SHORT_PRESS == val) || (KEY3_LONG_PRESS == val))
		movePrevious();
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void Screen1View::movePrevious()
{

}

void Screen1View::moveNext()
{

}

void Screen1View::moveNextScreen()
{
	application().gotoScreen2ScreenNoTransition();
}

void Screen1View::moveBackScreen()
{

}

void Screen1View::trigger()
{
#if (SDK_SERVICE_RTC == PS_ENABLE)
	uint8_t Seconds;
	uint8_t Minutes;
	uint8_t Hours;
	tickCounter++;

	if( 10 <= tickCounter)
	{
		tickCounter = 0;

		/* Get the RTC DB */
		Get_DL(GET_RTC_SECOND, &Seconds);
		Get_DL(GET_RTC_MINUTE, &Minutes);
		Get_DL(GET_RTC_HOUR, &Hours);

		digitalHours = Hours;
		digitalMinutes = Minutes;
		digitalSeconds = Seconds;

		digitalClock1.setTime24Hour(digitalHours, digitalMinutes, digitalSeconds);
	    digitalClock1.invalidate();
	}
#endif

	static uint16_t gauge;

	//Get_DL(ENGINE_SPEED, (uint8_t *)&gauge);
	if (gauge++>140) gauge=10;

//	ui_gauge = (uint8_t )(gauge*0.0175);
	ui_gauge=gauge;

	gauge1.setValue(ui_gauge);
	Unicode::snprintf(ENG_SPEED_TXTBuffer, ENG_SPEED_TXT_SIZE, "%d" , ui_gauge);

	ENG_SPEED_TXT.invalidate();

	/* Waring light state OFF */
	if(warning_light == 10)
	{
		image1.setAlpha(10);
		image2.setAlpha(10);
		image3.setAlpha(10);
		image4.setAlpha(10);

	    image1.invalidate();
	    image2.invalidate();
	    image3.invalidate();
	    image4.invalidate();



	}
	/* Waring light state ON */
	else
	if(warning_light == 20)
	{
		image1.setAlpha(255);
		image2.setAlpha(255);
		image3.setAlpha(255);
		image4.setAlpha(255);

		warning_light = 0;

        image1.invalidate();
        image2.invalidate();
        image3.invalidate();
        image4.invalidate();


	}

	warning_light++;

}

void Screen1View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
