#include <gui/screen2_screen/Screen2View.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"
#include <BitmapdataBase.hpp>

Screen2View::Screen2View()
{
	key_position = 1;

#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
	Get_DL(DIGITAL_OUTPUT_01_CFG, &dio_cfg);
	Get_DL(DIGITAL_OUTPUT_01_STATE, &state);
	if(state == CONF_DIGITAL_OUTPUT_OFF)
	{
		if(dio_cfg == CONF_HIGH_SIDE_DRIVER)
		{
			/* DESelect the Keypad button */
			highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
			highside_Button.invalidate();
		}
		else
		{
			/* DESelect the Keypad button */
			lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
			lowside_Button.invalidate();
		}
	}
	else
	if(state == CONF_DIGITAL_OUTPUT_ON)
	{
		if(dio_cfg == CONF_HIGH_SIDE_DRIVER)
		{
			/* DESelect the Keypad button */
			highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
			highside_Button.invalidate();
		}
		else
		if(dio_cfg == CONF_LOW_SIDE_DRIVER)
		{
			/* DESelect the Keypad button */
			lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
			lowside_Button.invalidate();
		}
	}
#endif
	/* Select the Keypad button */
	highside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	highside_txt.invalidate();

}

void Screen2View::setupScreen()
{
    Screen2ViewBase::setupScreen();
}

void Screen2View::tearDownScreen()
{
    Screen2ViewBase::tearDownScreen();
}

void Screen2View::keyUpdate(uint8_t val)
{
	uint32_t position = key_position;
	uint8_t current_config;

	if(KEY1_SHORT_PRESS == val)
		movePrevious();
	else
	if(KEY1_LONG_PRESS == val)
	{
		switch(position)
		{
			case 1:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
					state = CONF_HIGH_SIDE_DRIVER;
					Set_DL(DIGITAL_OUTPUT_01_CFG, &state);

					state = CONF_DIGITAL_OUTPUT_ON;
					Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
				}
#endif
				break;

			case 2:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
					state = CONF_LOW_SIDE_DRIVER;
					Set_DL(DIGITAL_OUTPUT_01_CFG, &state);

					state = CONF_DIGITAL_OUTPUT_ON;
					Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
				}
#endif
				break;
		}
	}
	else
	if(KEY2_SHORT_PRESS == val)
	{
		switch(position)
		{
			case 1:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
					highside_Button.invalidate();

                    dio_cfg = CONF_HIGH_SIDE_DRIVER;
                    Set_DL(DIGITAL_OUTPUT_01_CFG, &dio_cfg);

                    state = CONF_DIGITAL_OUTPUT_ON;
                    Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
                    Get_DL(DIGITAL_OUTPUT_01_CFG, &current_config);

                    if(current_config == CONF_LOW_SIDE_DRIVER)
                    {

                        lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
                        lowside_Button.invalidate();

                        highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
                        highside_Button.invalidate();

                        state = CONF_DIGITAL_OUTPUT_OFF;
                        Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

                        dio_cfg = CONF_HIGH_SIDE_DRIVER;
                        Set_DL(DIGITAL_OUTPUT_01_CFG, &dio_cfg);

                        state = CONF_DIGITAL_OUTPUT_ON;
                        Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

                    }
                    else
                    {
                        /* DESelect the Keypad button */
                        highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
                        highside_Button.invalidate();
                        state = CONF_DIGITAL_OUTPUT_OFF;
                        Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
                    }

				}
#endif
				break;

			case 2:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
					lowside_Button.invalidate();

                    dio_cfg = CONF_LOW_SIDE_DRIVER;
                    Set_DL(DIGITAL_OUTPUT_01_CFG, &dio_cfg);

                    state = CONF_DIGITAL_OUTPUT_ON;
                    Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
				    Get_DL(DIGITAL_OUTPUT_01_CFG, &current_config);

				    if(current_config == CONF_HIGH_SIDE_DRIVER)
				    {
	                    lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
	                    lowside_Button.invalidate();

	                    highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
	                    highside_Button.invalidate();

	                    state = CONF_DIGITAL_OUTPUT_OFF;
	                    Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

	                    dio_cfg = CONF_LOW_SIDE_DRIVER;
	                    Set_DL(DIGITAL_OUTPUT_01_CFG, &dio_cfg);

	                    state = CONF_DIGITAL_OUTPUT_ON;
	                    Set_DL(DIGITAL_OUTPUT_01_STATE, &state);

				    }
				    else
				    {
                        lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
                        lowside_Button.invalidate();
                        state = CONF_DIGITAL_OUTPUT_OFF;
                        Set_DL(DIGITAL_OUTPUT_01_STATE, &state);
				    }

				}
#endif
				break;
		}
	}
	else
	if(KEY2_LONG_PRESS == val)
	{
		key_position++;

		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
			case 1:
				/* DESelect the Keypad button */
				ign_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				ign_txt.invalidate();

				/* Select the Keypad button */
				highside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				highside_txt.invalidate();
				break;

			case 2:
				/* DESelect the Keypad button */
				highside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				highside_txt.invalidate();

				/* Select the Keypad button */
				lowside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				lowside_txt.invalidate();
				break;

			case 3:
				/* DESelect the Keypad button */
				lowside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				lowside_txt.invalidate();

				/* Select the Keypad button */
				ign_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				ign_txt.invalidate();
				break;

			default:
				break;
		}
	}
	else
	if(KEY3_SHORT_PRESS == val)
	{
		switch(position)
		{
			case 1:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
					highside_Button.invalidate();
					state = CONF_DIGITAL_OUTPUT_ON;
				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
					/* DESelect the Keypad button */
					highside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
					highside_Button.invalidate();
					state = CONF_DIGITAL_OUTPUT_OFF;
				}
#endif
				break;

			case 2:
#if (SDK_SERVICE_DIGITAL_OUTPUT == PS_ENABLE)
				if(state == CONF_DIGITAL_OUTPUT_OFF)
				{
					lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
					lowside_Button.invalidate();
					state = CONF_DIGITAL_OUTPUT_ON;
				}
				else
				if(state == CONF_DIGITAL_OUTPUT_ON)
				{
					/* DESelect the Keypad button */
					lowside_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
					lowside_Button.invalidate();
					state = CONF_DIGITAL_OUTPUT_OFF;
				}
#endif
				break;
		}
	}
	else
	if(KEY3_LONG_PRESS == val)
	{
		key_position--;

		if (0 == key_position)
			key_position = 3;

		switch(key_position)
		{
			case 1:
				/* Select the Keypad button */
				highside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				highside_txt.invalidate();

				/* DESelect the Keypad button */
				lowside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				lowside_txt.invalidate();
				break;

			case 2:
				/* Select the Keypad button */
				lowside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				lowside_txt.invalidate();

				/* DESelect the Keypad button */
				ign_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				ign_txt.invalidate();
				break;

			case 3:
				/* Select the Keypad button */
				ign_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				ign_txt.invalidate();

				/* DESelect the Keypad button */
				highside_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				highside_txt.invalidate();
				break;

			default:
				break;
		}
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void Screen2View::movePrevious()
{
	application().gotoScreen3ScreenNoTransition();
}

void Screen2View::moveBackScreen()
{
	application().gotoScreen1ScreenNoTransition();
}

void Screen2View::trigger()
{
	uint32_t val = 0;
	update_val ++;

	if (33 > update_val)
	{
		return;
	}

	update_val = 0;

	val = 0;
#if (SDK_SERVICE_POWER_MONITOR == PS_ENABLE)
	Get_DL(IGNITION_STATUS, (uint8_t*)&val);
#endif

	if(val == 1)
	{
		ign_Button.setBitmaps(touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID), touchgfx::Bitmap(BITMAP_ON_BUTTON2_ID));
		ign_Button.invalidate();
	}
	else
	if(val == 0)
	{
		ign_Button.setBitmaps(touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID), touchgfx::Bitmap(BITMAP_OFF_BUTTON2_ID));
		ign_Button.invalidate();
	}

//	this->getRootContainer().invalidate();
}

void Screen2View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
