#include <gui/screen3_screen/Screen3View.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

Screen3View::Screen3View()
{
	key_position = 1;
	cur_di_state = 1;
	cur_res      = 1;
	cur_Freq     = 1;
	cur_voltage  = 1;

	/* Select the Keypad button */
	dio_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	dio_txt.invalidate();
}

void Screen3View::setupScreen()
{
    Screen3ViewBase::setupScreen();
}

void Screen3View::tearDownScreen()
{
    Screen3ViewBase::tearDownScreen();
}

void Screen3View::keyUpdate(uint8_t val)
{
	uint32_t position = key_position;

	if(KEY1_SHORT_PRESS == val)
	{
		application().gotoScreen4ScreenNoTransition();
	}
	else
	if(KEY1_LONG_PRESS == val)
	{
		switch(position)
		{
			case 1:
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
				cfg_type = CI_DIGITAL_STB;

				if(cur_di_state == 1)
				{
					Set_DL(CFG_INPUT_01_TYPE , &cfg_type);
				}
				else
				if(cur_di_state == 2)
				{
					Set_DL(CFG_INPUT_02_TYPE , &cfg_type);
				}
				else
				if(cur_di_state == 3)
				{
					Set_DL(CFG_INPUT_03_TYPE , &cfg_type);
				}
				else
				if(cur_di_state == 4)
				{
					Set_DL(CFG_INPUT_04_TYPE , &cfg_type);
				}
				else
				if(cur_di_state == 5)
				{
					Set_DL(CFG_INPUT_05_TYPE , &cfg_type);
				}
#endif
				break;

			case 2:
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
				cfg_type = CI_INPUT_RESISTANCE;

				if(cur_res == 1)
				{
					Set_DL(CFG_INPUT_01_TYPE , &cfg_type);
				}
				else
				if(cur_res == 2)
				{
					Set_DL(CFG_INPUT_02_TYPE , &cfg_type);
				}
				else
				if(cur_res == 3)
				{
					Set_DL(CFG_INPUT_03_TYPE , &cfg_type);
				}
				else
				if(cur_res == 4)
				{
					Set_DL(CFG_INPUT_04_TYPE , &cfg_type);
				}
				else
				if(cur_res == 5)
				{
					Set_DL(CFG_INPUT_05_TYPE , &cfg_type);
				}
#endif
				break;

			case 3:
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
				cfg_type = CI_INPUT_FREQUENCY;

				if(cur_Freq == 1)
				{
					Set_DL(CFG_INPUT_01_TYPE , &cfg_type);
				}
				else
				if(cur_Freq == 2)
				{
					Set_DL(CFG_INPUT_02_TYPE , &cfg_type);
				}
				else
				if(cur_Freq == 3)
				{
					Set_DL(CFG_INPUT_03_TYPE , &cfg_type);
				}
				else
				if(cur_Freq == 4)
				{
					Set_DL(CFG_INPUT_04_TYPE , &cfg_type);
				}
				else
				if(cur_Freq == 5)
				{
					Set_DL(CFG_INPUT_05_TYPE , &cfg_type);
				}
#endif
				break;

			case 4:
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
				cfg_type = CI_INPUT_VOLTAGE_HIGH;

				if(cur_voltage == 1)
				{
					Set_DL(CFG_INPUT_01_TYPE , &cfg_type);
				}
				else
				if(cur_voltage == 2)
				{
					Set_DL(CFG_INPUT_02_TYPE , &cfg_type);
				}
				else
				if(cur_voltage == 3)
				{
					Set_DL(CFG_INPUT_03_TYPE , &cfg_type);
				}
				else
				if(cur_voltage == 4)
				{
					Set_DL(CFG_INPUT_04_TYPE , &cfg_type);
				}
				else
				if(cur_voltage == 5)
				{
					Set_DL(CFG_INPUT_05_TYPE , &cfg_type);
				}
#endif
				break;
		}
	}
	else
	if(KEY2_SHORT_PRESS == val)
	{
		switch(position)
		{
			case 1:
				if ((cur_di_state > 1) && (cur_di_state <= 5))
				{
					cur_di_state--;
					Unicode::snprintf(digital_ioBuffer, DIGITAL_IO_SIZE, "%d" , cur_di_state);
				}
				digital_io.invalidate();
				break;

			case 2:
				if ((cur_res > 1) && (cur_res <= 5))
				{
					cur_res--;
					Unicode::snprintf(resistanceBuffer, RESISTANCE_SIZE, "%d" , cur_res);
				}
				resistance.invalidate();
				break;

			case 3:
				if ((cur_Freq > 1) && (cur_Freq <= 5))
				{
					cur_Freq--;
					Unicode::snprintf(frequencyBuffer, FREQUENCY_SIZE, "%d" , cur_Freq);
				}
				frequency.invalidate();
				break;

			case 4:
				if ((cur_voltage > 1) && (cur_voltage <= 5))
				{
					cur_voltage--;
					Unicode::snprintf(voltageBuffer, VOLTAGE_SIZE, "%d" , cur_voltage);
				}
				voltage.invalidate();
				break;
		}
	}
	else
	if(KEY2_LONG_PRESS == val)
	{
		key_position++;

		if (5 == key_position)
			key_position = 1;

		switch(key_position)
		{
			case 1:
				/* DESelect the Keypad button */
				voltage_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				voltage_txt.invalidate();

				/* Select the Keypad button */
				dio_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				dio_txt.invalidate();
				break;

			case 2:
				/* DESelect the Keypad button */
				dio_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				dio_txt.invalidate();

				/* Select the Keypad button */
				res_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				res_txt.invalidate();
				break;

			case 3:
				/* DESelect the Keypad button */
				res_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				res_txt.invalidate();

				/* Select the Keypad button */
				freq_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				freq_txt.invalidate();
				break;

			case 4:
				/* DESelect the Keypad button */
				freq_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				freq_txt.invalidate();

				/* Select the Keypad button */
				voltage_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				voltage_txt.invalidate();
				break;

			default:
				break;
		}
	}
	else
	if(KEY3_SHORT_PRESS == val)
	{
		switch(position)
		{
			case 1:
				if ((cur_di_state > 0) && (cur_di_state < 5))
				{
					cur_di_state++;
					Unicode::snprintf(digital_ioBuffer, DIGITAL_IO_SIZE, "%d" , cur_di_state);
				}
				digital_io.invalidate();
				break;

			case 2:
				if ((cur_res > 0) && (cur_res < 5))
				{
					cur_res++;
					Unicode::snprintf(resistanceBuffer, RESISTANCE_SIZE, "%d" , cur_res);
				}
				resistance.invalidate();
				break;

			case 3:
				if ((cur_Freq > 0) && (cur_Freq < 5))
				{
					cur_Freq++;
					Unicode::snprintf(frequencyBuffer, FREQUENCY_SIZE, "%d" , cur_Freq);
				}
				frequency.invalidate();
				break;

			case 4:
				if ((cur_voltage > 0) && (cur_voltage < 5))
				{
					cur_voltage++;
					Unicode::snprintf(voltageBuffer, VOLTAGE_SIZE, "%d" , cur_voltage);
				}
				voltage.invalidate();
				break;
		}
	}
	else
	if(KEY3_LONG_PRESS == val)
	{
	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void Screen3View::movePrevious()
{

}

void Screen3View::moveNext()
{

}

void Screen3View::moveNextScreen()
{

}

void Screen3View::moveBackScreen()
{
	application().gotoScreen2ScreenNoTransition();
}

void Screen3View::trigger()
{
#if (SDK_SERVICE_CFG_INPUT == PS_ENABLE)
	uint32_t val = 0;

	update_val ++;

	/* Update AI1 Value */
	if (33 > update_val)
	{
		return;
	}

	update_val = 0;

	switch(key_position)
	{
		case 1:
			if(cur_di_state == 1)
			{
				val = 0;
				Get_DL(CFG_INPUT_01_DIGITAL_STB , (uint8_t *)&val);

				if(val == 1)
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "ON");
				}
				else
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "OFF");
				}
				dio_state_val.invalidate();
			}
			else
			if(cur_di_state == 2)
			{
				val = 0;
				Get_DL(CFG_INPUT_02_DIGITAL_STB , (uint8_t *)&val);

				if(val == 1)
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "ON");
				}
				else
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "OFF");
				}
				dio_state_val.invalidate();
			}
			else
			if(cur_di_state == 3)
			{
				val = 0;
				Get_DL(CFG_INPUT_03_DIGITAL_STB , (uint8_t *)&val);

				if(val == 1)
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "ON");
				}
				else
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "OFF");
				}
				dio_state_val.invalidate();
			}
			else
			if(cur_di_state == 4)
			{
				val = 0;
				Get_DL(CFG_INPUT_04_DIGITAL_STB , (uint8_t *)&val);

				if(val == 1)
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "ON");
				}
				else
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "OFF");
				}
				dio_state_val.invalidate();
			}
			else
			if(cur_di_state == 5)
			{
				val = 0;
				Get_DL(CFG_INPUT_05_DIGITAL_STB , (uint8_t *)&val);

				if(val == 1)
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "ON");
				}
				else
				{
					Unicode::snprintf(dio_state_valBuffer, DIO_STATE_VAL_SIZE, "OFF");
				}
				dio_state_val.invalidate();
			}
			break;

		case 2:
			if(cur_res == 1)
			{
				val = 0;
				Get_DL(CFG_INPUT_01_RESISTANCE , (uint8_t *)&val);

				Unicode::snprintf(resistance_valBuffer, RESISTANCE_VAL_SIZE, "%d" , val);
				resistance_val.invalidate();
			}
			else
			if(cur_res == 2)
			{
				val = 0;
				Get_DL(CFG_INPUT_02_RESISTANCE , (uint8_t *)&val);

				Unicode::snprintf(resistance_valBuffer, RESISTANCE_VAL_SIZE, "%d" , val);
				resistance_val.invalidate();
			}
			else
			if(cur_res == 3)
			{
				val = 0;
				Get_DL(CFG_INPUT_03_RESISTANCE , (uint8_t *)&val);

				Unicode::snprintf(resistance_valBuffer, RESISTANCE_VAL_SIZE, "%d" , val);
				resistance_val.invalidate();
			}
			else
			if(cur_res == 4)
			{
				val = 0;
				Get_DL(CFG_INPUT_04_RESISTANCE , (uint8_t *)&val);

				Unicode::snprintf(resistance_valBuffer, RESISTANCE_VAL_SIZE, "%d" , val);
				resistance_val.invalidate();
			}
			else
			if(cur_res == 5)
			{
				val = 0;
				Get_DL(CFG_INPUT_05_RESISTANCE , (uint8_t *)&val);

				Unicode::snprintf(resistance_valBuffer, RESISTANCE_VAL_SIZE, "%d" , val);
				resistance_val.invalidate();
			}
			break;

		case 3:
			if(cur_Freq == 1)
			{
				val = 0;
				Get_DL(CFG_INPUT_01_FREQUENCY , (uint8_t *)&val);

				Unicode::snprintf(frequency_valBuffer, FREQUENCY_VAL_SIZE, "%d" , val);
				frequency_val.invalidate();
			}
			else
			if(cur_Freq == 2)
			{
				val = 0;
				Get_DL(CFG_INPUT_02_FREQUENCY , (uint8_t *)&val);

				Unicode::snprintf(frequency_valBuffer, FREQUENCY_VAL_SIZE, "%d" , val);
				frequency_val.invalidate();
			}
			else
			if(cur_Freq == 3)
			{
				val = 0;
				Get_DL(CFG_INPUT_03_FREQUENCY , (uint8_t *)&val);

				Unicode::snprintf(frequency_valBuffer, FREQUENCY_VAL_SIZE, "%d" , val);
				frequency_val.invalidate();
			}
			else
			if(cur_Freq == 4)
			{
				val = 0;
				Get_DL(CFG_INPUT_04_FREQUENCY , (uint8_t *)&val);

				Unicode::snprintf(frequency_valBuffer, FREQUENCY_VAL_SIZE, "%d" , val);
				frequency_val.invalidate();
			}
			else
			if(cur_Freq == 5)
			{
				val = 0;
				Get_DL(CFG_INPUT_05_FREQUENCY , (uint8_t *)&val);

				Unicode::snprintf(frequency_valBuffer, FREQUENCY_VAL_SIZE, "%d" , val);
				frequency_val.invalidate();
			}
			break;

		case 4:
			if(cur_voltage == 1)
			{
				val = 0;
				Get_DL(CFG_INPUT_01_VOLTAGE_32V , (uint8_t *)&val);

				Unicode::snprintf(voltage_valBuffer, VOLTAGE_VAL_SIZE, "%d" , val);
				voltage_val.invalidate();
			}
			else
			if(cur_voltage == 2)
			{
				val = 0;
				Get_DL(CFG_INPUT_02_VOLTAGE_32V , (uint8_t *)&val);

				Unicode::snprintf(voltage_valBuffer, VOLTAGE_VAL_SIZE, "%d" , val);
				voltage_val.invalidate();
			}
			else
			if(cur_voltage == 3)
			{
				val = 0;
				Get_DL(CFG_INPUT_03_VOLTAGE_32V , (uint8_t *)&val);

				Unicode::snprintf(voltage_valBuffer, VOLTAGE_VAL_SIZE, "%d" , val);
				voltage_val.invalidate();
			}
			else
			if(cur_voltage == 4)
			{
				val = 0;
				Get_DL(CFG_INPUT_04_VOLTAGE_32V , (uint8_t *)&val);

				Unicode::snprintf(voltage_valBuffer, VOLTAGE_VAL_SIZE, "%d" , val);
				voltage_val.invalidate();
			}
			else
			if(cur_voltage == 5)
			{
				val = 0;
				Get_DL(CFG_INPUT_05_VOLTAGE_32V , (uint8_t *)&val);

				Unicode::snprintf(voltage_valBuffer, VOLTAGE_VAL_SIZE, "%d" , val);
				voltage_val.invalidate();
			}
			break;

		default:
			break;
	}
#endif

//	this->getRootContainer().invalidate();
}

void Screen3View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
