#include <gui/screen4_screen/Screen4View.hpp>
#include "string.h"
#include <touchgfx/Color.hpp>
#include "../../../../Core/Maximatecc/user_modify_files/User_Define.h"

uint32_t swtimeout_val;

Screen4View::Screen4View()
{
	state = 1;
	shot = 1;
	key_position = 1;
	inc_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
	inc_txt.invalidate();

	timeout = 0;
	Get_DL(START_EEPROM + (EE_CAL01),(uint8_t *)&timeout);

	Unicode::snprintf(TimeoutBuffer, TIMEOUT_SIZE, "%d", timeout);
	Timeout.invalidate();

	timeout = 0;
}

void Screen4View::setupScreen()
{
    Screen4ViewBase::setupScreen();
}

void Screen4View::tearDownScreen()
{
    Screen4ViewBase::tearDownScreen();
}

void Screen4View::keyUpdate(uint8_t val)
{
	if((KEY1_SHORT_PRESS == val) || (KEY1_LONG_PRESS == val))
		movePrevious();
	else
	if(KEY2_SHORT_PRESS == val)
	{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)

		switch(key_position)
		{
			case 1:
				if ((timeout < 65535) && (timeout >= 0))
				{
					timeout ++;
					sw_timeout = (timeout * 50);
					Unicode::snprintf(SWTimer_valBuffer, SWTIMER_VAL_SIZE, " %d" , sw_timeout);
				}
				else
				{
					Unicode::snprintf(SWTimer_valBuffer, SWTIMER_VAL_SIZE, "Max-%d" , timeout);
				}

				/* Set the Timer Timeout_1 */
				SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

				SWTimer_val.invalidate();
				break;
		}
#endif
	}
	else
	if(KEY2_LONG_PRESS == val)
	{
		key_position++;
		if (4 == key_position)
			key_position = 1;

		switch(key_position)
		{
			case 1:
				/* DESelect the Keypad button */
				textArea4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				textArea4.invalidate();

				/* Select the Keypad button */
				inc_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				inc_txt.invalidate();
				break;

			case 2:
				/* DESelect the Keypad button */
				inc_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				inc_txt.invalidate();

				/* Select the Keypad button */
				dec_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				dec_txt.invalidate();
				break;

			case 3:
				/* DESelect the Keypad button */
				dec_txt.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));
				dec_txt.invalidate();

				/* Select the Keypad button */
				textArea4.setColor(touchgfx::Color::getColorFromRGB(0, 0, 255));
				textArea4.invalidate();
				break;

			default:
				break;
		}
	}
	else
	if(KEY3_SHORT_PRESS == val)
	{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
		switch(key_position)
		{
			case 2:
				if ((timeout > 0) && (timeout <= 65535))
				{
					timeout --;
					sw_timeout = (timeout * 50);
					Unicode::snprintf(SWTimer_valBuffer, SWTIMER_VAL_SIZE, " %d" , sw_timeout);
				}
				else
				{
					Unicode::snprintf(SWTimer_valBuffer, SWTIMER_VAL_SIZE, "Min-%d" , timeout);
				}

				/* Set the Timer Timeout_1 */
				SET_DB(TIMER_TIMEOUT_01, (uint8_t *)&sw_timeout);

				SWTimer_val.invalidate();
				break;
		}
#endif
	}
	else
	if(KEY3_LONG_PRESS == val)
	{

	}
	else
	if((KEY4_SHORT_PRESS == val) || (KEY4_LONG_PRESS == val))
		moveBackScreen();
}

void Screen4View::movePrevious()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
		switch(key_position)
		{
			case 1:
				SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
				SET_DB(TIMER_STATUS_01, (uint8_t *)&state);
				break;

			case 2:
				SET_DB(TIMER_MODE_01, (uint8_t *)&shot);
				SET_DB(TIMER_STATUS_01, (uint8_t *)&state);
				break;

			case 3:
#if (SDK_SERVICE_PM == PS_ENABLE)
				pm_state = PM_STOP_MODE;
				Set_DL(POWER_MODE, &pm_state);
#endif
				break;

			default:
				break;
		}
#endif
}

void Screen4View::moveBackScreen()
{
	application().gotoScreen3ScreenNoTransition();
}

void Screen4View::trigger()
{
#if (SDK_SERVICE_SWTIMER == PS_ENABLE)
	uint8_t timer1_state = 0;

	Get_DL(TIMER_CALLBACK_01, &timer1_state);

	if(CALLBACK_OCCURED == timer1_state)
	{
		/* Update the timeout value to EEPROM */
		Set_DL(START_EEPROM + (EE_CAL01),(uint8_t *)&swtimeout_val);

		Unicode::snprintf(TimeoutBuffer, TIMEOUT_SIZE, "%d", swtimeout_val);
		Timeout.invalidate();

		swtimeout_val++;
	}
#endif

	this->getRootContainer().invalidate();
}

void Screen4View::watchdogstatus(uint8_t *val)
{
	*val = 0;
}
