
#include "stm32h7xx_hal.h"
#include "stm32h7xx_hal_tim.h"

#include <touchgfx/hal/HAL.hpp>
#include <STM32H7Instrumentation.hpp>
#include "../../Core/Maximatecc/Inc/Common.h"


extern TIM_HandleTypeDef htim5;


namespace touchgfx
{


static TIM_HandleTypeDef tim;

void STM32H7Instrumentation::init()
{
//    TIM_HandleTypeDef htim5;

    RCC_ClkInitTypeDef    clkconfig;
//    uint32_t              uwTimclock, uwAPB1Prescaler;
//    uint32_t              uwPrescalerValue;
    uint32_t              pFLatency;

    /* Deinitialize the Timer4 */

    HAL_TIM_Base_DeInit(&htim5);

    HAL_NVIC_SetPriority(TIM5_IRQn, 15UL ,0U);
    /* Enable the TIM5 global Interrupt */
    HAL_NVIC_EnableIRQ(TIM5_IRQn);

    /* Enable TIM5 clock */
    __HAL_RCC_TIM5_CLK_ENABLE();

    /* Get clock configuration */
    HAL_RCC_GetClockConfig(&clkconfig, &pFLatency);

//    /* Get APB1 prescaler */
//    uwAPB1Prescaler = clkconfig.APB1CLKDivider;
//
//    /* Compute TIM5 clock */
//    if (uwAPB1Prescaler == RCC_HCLK_DIV1)
//    {
//        uwTimclock = HAL_RCC_GetPCLK1Freq();
//    }
//    else
//    {
//        uwTimclock = 2UL * HAL_RCC_GetPCLK1Freq();
//    }

    /* Compute the prescaler value to have TIM5 counter clock equal to 1MHz */
//    uwPrescalerValue = (uint32_t) ((uwTimclock / 1000000U) - 1U);

    /* Initialize TIM5 */
    htim5.Instance = TIM5;

    /* Initialize TIMx peripheral as follow:
     * Period = [(TIM5CLK/1000) - 1]. to have a (1/1000) s time base.
     * Prescaler = (uwTimclock/1000000 - 1) to have a 1MHz counter clock.
     * ClockDivision = 0
     * Counter direction = Up
     * */
    htim5.Init.Period = 65535;//999
    htim5.Init.Prescaler = 250;//30FPS //239
    htim5.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
    htim5.Init.CounterMode = TIM_COUNTERMODE_UP;

    if(HAL_TIM_Base_Init(&htim5) == HAL_OK)
    {
        HAL_TIM_Base_Start_IT(&htim5);
    }


}

//Board specific clockfrequency
unsigned int STM32H7Instrumentation::getElapsedUS(unsigned int start, unsigned int now, unsigned int clockfrequency)
{
    return ((now - start) + (clockfrequency / 2)) / clockfrequency;
}


unsigned int STM32H7Instrumentation::getCPUCycles()
{
    return __HAL_TIM_GET_COUNTER(&tim);
}

void STM32H7Instrumentation::setMCUActive(bool active)
{
    if (active) //idle task sched out
    {
        uint32_t current_cc = cc_in;
        cc_consumed += getCPUCycles() - current_cc;
    }
    else //idle task sched in
    {
        cc_in = getCPUCycles();
    }
}
}
